/*  kn-data-stream.c - The simplest kernel module.

* Copyright (C) 2013 - 2016 Xilinx, Inc
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.

*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License along
*   with this program. If not, see <http://www.gnu.org/licenses/>.

*/
#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/ioctl.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/slab.h>
#include <linux/io.h>
#include <linux/interrupt.h>

#include <linux/device.h>         // Header to support the kernel Driver Model
#include <linux/fs.h>             // Header for the Linux file system support
#include <linux/cdev.h>
#include <linux/uaccess.h>          // Required for the copy to user function

#include <linux/of_address.h>
#include <linux/of_device.h>
#include <linux/of_platform.h>

/* Standard module information, edit as appropriate */
MODULE_LICENSE("GPL");
MODULE_AUTHOR("ME");
MODULE_DESCRIPTION("kn-data-stream - loadable module template generated by petalinux-create -t modules");

#define CONFIG_OF

#define MY_IOCTL_DATA_TO_READ _IOC(_IOC_READ, 'k', 1, sizeof(unsigned short))

#define BUFFER_LENGTH 20000               ///< The buffer length (crude but fine)

#define MAX_DEVICES  5
#define DRIVER_NAME "kn-data-stream"
#define DEVICE_NAME "knstreamer"
#define CLASS_NAME "kn" 

/* Simple example of how to receive command line parameters to your module.
   Delete if you don't need them */
unsigned myint = 0xdeadbeef;
char *mystr = "KeyNetic";

module_param(myint, int, S_IRUGO);
module_param(mystr, charp, S_IRUGO);

static int    majorNumber;                  ///< Stores the device number -- determined automatically
static char   message[BUFFER_LENGTH] = {0};           ///< Memory for the string that is passed from userspace
static short  size_of_message;              ///< Used to remember the size of the string stored
static int    numberOpens = 0; 
static struct class*  knstreamerClass  = NULL; ///< The device-driver class struct pointer
static struct device* knstreamerDevice = NULL; ///< The device-driver device struct pointer
static struct cdev cdev[MAX_DEVICES];

struct kn_data_stream_local {
	int irq;
	unsigned long mem_start;
	unsigned long mem_end;
	void __iomem *base_addr;
};

dev_t dev = 0;

// The prototype functions for the character driver -- must come before the struct definition
static int		dev_open(struct inode *, struct file *);
static int		dev_release(struct inode *, struct file *);
static long 	dev_ioctl (struct file *file, unsigned int cmd, unsigned long arg);
static ssize_t	dev_read(struct file *, char *, size_t, loff_t *);
static ssize_t	dev_write(struct file *, const char *, size_t, loff_t *);

/** @brief Devices are represented as file structure in the kernel. The file_operations structure from
 *  /linux/fs.h lists the callback functions that you wish to associated with your file operations
 *  using a C99 syntax structure. char devices usually implement open, read, write and release calls
 */
static struct file_operations fops =
{
   .open = dev_open,
   .read = dev_read,
   .write = dev_write,
   .release = dev_release,
   .unlocked_ioctl = dev_ioctl
};

static irqreturn_t kn_data_stream_irq(int irq, void *lp)
{
	printk("kn-data-stream interrupt\n");
	return IRQ_HANDLED;
}

static int kn_data_stream_probe(struct platform_device *pdev)
{
	struct resource *r_irq; /* Interrupt resources */
	struct resource *r_mem; /* IO mem resources */
	struct device *dev = &pdev->dev;
	struct kn_data_stream_local *lp = NULL;

	int rc = 0;
	dev_info(dev, "Device Tree Probing\n");
	/* Get iospace for the device */
	r_mem = platform_get_resource(pdev, IORESOURCE_MEM, 0);
	if (!r_mem) {
		dev_err(dev, "invalid address\n");
		return -ENODEV;
	}
	lp = (struct kn_data_stream_local *) kmalloc(sizeof(struct kn_data_stream_local), GFP_KERNEL);
	if (!lp) {
		dev_err(dev, "Cound not allocate kn-data-stream device\n");
		return -ENOMEM;
	}
	dev_set_drvdata(dev, lp);
	lp->mem_start = r_mem->start;
	lp->mem_end = r_mem->end;

	if (!request_mem_region(lp->mem_start,
				lp->mem_end - lp->mem_start + 1,
				DRIVER_NAME)) {
		dev_err(dev, "Couldn't lock memory region at %p\n",
			(void *)lp->mem_start);
		rc = -EBUSY;
		goto error1;
	}

	lp->base_addr = ioremap(lp->mem_start, lp->mem_end - lp->mem_start + 1);
	if (!lp->base_addr) {
		dev_err(dev, "kn-data-stream: Could not allocate iomem\n");
		rc = -EIO;
		goto error2;
	}

	/* Get IRQ for the device */
	r_irq = platform_get_resource(pdev, IORESOURCE_IRQ, 0);
	if (!r_irq) {
		dev_info(dev, "no IRQ found\n");
		dev_info(dev, "kn-data-stream at 0x%08x mapped to 0x%08x\n",
			(unsigned int __force)lp->mem_start,
			(unsigned int __force)lp->base_addr);
		return 0;
	}
	lp->irq = r_irq->start;
	rc = request_irq(lp->irq, &kn_data_stream_irq, 0, DRIVER_NAME, lp);
	if (rc) {
		dev_err(dev, "testmodule: Could not allocate interrupt %d.\n",
			lp->irq);
		goto error3;
	}

	dev_info(dev,"kn-data-stream at 0x%08x mapped to 0x%08x, irq=%d\n",
		(unsigned int __force)lp->mem_start,
		(unsigned int __force)lp->base_addr,
		lp->irq);
	return 0;
error3:
	free_irq(lp->irq, lp);
error2:
	release_mem_region(lp->mem_start, lp->mem_end - lp->mem_start + 1);
error1:
	kfree(lp);
	dev_set_drvdata(dev, NULL);
	return rc;
}

static int kn_data_stream_remove(struct platform_device *pdev)
{
	struct device *dev = &pdev->dev;
	struct kn_data_stream_local *lp = dev_get_drvdata(dev);
	free_irq(lp->irq, lp);
	iounmap(lp->base_addr);
	release_mem_region(lp->mem_start, lp->mem_end - lp->mem_start + 1);
	kfree(lp);
	dev_set_drvdata(dev, NULL);
	return 0;
}

#ifdef CONFIG_OF
static struct of_device_id kn_data_stream_of_match[] = {
	{ .compatible = "vendor,kn-data-stream", },
	{ /* end of list */ },
};
MODULE_DEVICE_TABLE(of, kn_data_stream_of_match);
#else
# define kn_data_stream_of_match
#endif


static struct platform_driver kn_data_stream_driver = {
	.driver = {
		.name = DRIVER_NAME,
		.owner = THIS_MODULE,
		.of_match_table	= kn_data_stream_of_match,
	},
	.probe		= kn_data_stream_probe,
	.remove		= kn_data_stream_remove,
};

static int __init kn_data_stream_init(void)
{
	int retval, i;

	printk("<1>Hello module world.\n");
	printk("<1>Module parameters were (0x%08x) and \"%s\"\n", myint, mystr);

	//you are asking VFS for the device ID
	retval = alloc_chrdev_region(&dev, 0, MAX_DEVICES, DEVICE_NAME);
	if (retval != 0) {
        printk("\n Error: alloc__chrdev_region \n");
        return retval;
    }
	printk("Major No: %d Minor_no : %d \n", MAJOR(dev), MINOR(dev));

    if (!retval) {
	    int major = MAJOR(dev);
	    dev_t my_device;
	    knstreamerClass = class_create(THIS_MODULE, CLASS_NAME);
	    for (i = 0; i < MAX_DEVICES; i++) {
		    my_device = MKDEV(major, i);
		    cdev_init(&cdev[i], &fops);
		    retval = cdev_add(&cdev[i], my_device, 1);
		    if (retval) {
			    pr_info("%s: Failed in adding cdev to subsystem "
					    "retval:%d\n", __func__, retval);
		    }
		    else {
			    device_create(knstreamerClass, NULL, my_device, NULL, "stream%d", i);
		    }
	    }
    }
    else
	    pr_err("%s: Failed in allocating device number "
			    "Error:%d\n", __func__, retval);
    return retval;
}


static void __exit kn_data_stream_exit(void)
{
	int i = 0;
	int major = MAJOR(dev);
	dev_t my_device;
	for (i = 0; i < MAX_DEVICES; i++) {
		my_device = MKDEV(major, i);
		cdev_del(&cdev[i]);
		device_destroy(knstreamerClass, my_device);
	}
	class_destroy(knstreamerClass);
	unregister_chrdev_region(dev, MAX_DEVICES);
	pr_info("%s: In exit\n", __func__);

	
	printk(KERN_ALERT "Goodbye module world.\n");
}

/** @brief The device open function that is called each time the device is opened
 *  This will only increment the numberOpens counter in this case.
 *  @param inodep A pointer to an inode object (defined in linux/fs.h)
 *  @param filep A pointer to a file object (defined in linux/fs.h)
 */
static int dev_open(struct inode *inodep, struct file *filep){
   numberOpens++;
   printk(KERN_INFO "KnStreamer: Device has been opened %d time(s)\n", numberOpens);
   return 0;
}

static long dev_ioctl (struct file *file, unsigned int cmd, unsigned long arg)
{
    unsigned short mid;

    switch(cmd) 
	{
		case MY_IOCTL_DATA_TO_READ:
			if(copy_to_user((unsigned long *) arg, &size_of_message, sizeof(size_of_message)))
			{
				pr_err("Data Read : Err!\n");
				return -EFAULT;
			}				

			//printk(KERN_INFO "KnStreamer: MY_IOCTL_OUT recv %d\n", size_of_message);
			/* process data and execute command */

			break;
		default:
			return -ENOTTY;
    }

    return 0;
}

/** @brief This function is called whenever device is being read from user space i.e. data is
 *  being sent from the device to the user. In this case is uses the copy_to_user() function to
 *  send the buffer string to the user and captures any errors.
 *  @param filep A pointer to a file object (defined in linux/fs.h)
 *  @param buffer The pointer to the buffer to which this function writes the data
 *  @param len The length of the b
 *  @param offset The offset if required
 */
static ssize_t dev_read(struct file *filep, char *buffer, size_t len, loff_t *offset){
	int error_count = 0;

	ssize_t size = size_of_message;
	size_of_message = 0;
	// copy_to_user has the format ( * to, *from, size) and returns 0 on success
	error_count = copy_to_user(buffer, message, size);

	if (error_count!=0)
	{ 
		printk(KERN_INFO "KnStreamer: Failed to send %d characters to the user\n", error_count);
		return -EFAULT;              // Failed -- return a bad address message (i.e. -14)
	}
	
	*offset += size;
	
    return size;
}

/** @brief This function is called whenever the device is being written to from user space i.e.
 *  data is sent to the device from the user. The data is copied to the message[] array in this
 *  LKM using the sprintf() function along with the length of the string.
 *  @param filep A pointer to a file object
 *  @param buffer The buffer to that contains the string to write to the device
 *  @param len The length of the array of data that is being passed in the const char buffer
 *  @param offset The offset if required
 */
static ssize_t dev_write(struct file *filep, const char *buffer, size_t len, loff_t *offset){
   copy_from_user(message, buffer, len);
   size_of_message = len;                 // store the length of the stored message
   printk(KERN_INFO "KnStreamer: Received %zu characters from the user\n", size_of_message);
   printk(KERN_INFO "KnStreamer: Msg : %s \n", message);
   return len;
}

/** @brief The device release function that is called whenever the device is closed/released by
 *  the userspace program
 *  @param inodep A pointer to an inode object (defined in linux/fs.h)
 *  @param filep A pointer to a file object (defined in linux/fs.h)
 */
static int dev_release(struct inode *inodep, struct file *filep){
   printk(KERN_INFO "KnStreamer: Device successfully closed\n");
   return 0;
}

module_init(kn_data_stream_init);
module_exit(kn_data_stream_exit);
